#property link      "http://www.themovingaverage.com"
#property indicator_chart_window

//   2010-02-02 Vinin
//        

#property indicator_buffers 6
#property indicator_color1 Yellow
#property indicator_color2 MediumAquamarine
#property indicator_color3 Red
#property indicator_color4 LimeGreen
#property indicator_color5 Red
#property indicator_color6 LimeGreen

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer11[];
double ExtMapBuffer12[];

extern int firstback=50;
extern int secondback=14;
extern int countbars=2000;
extern int power=2;

int init()
  {
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexBuffer(3,ExtMapBuffer4);

   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexArrow(2,108);
   SetIndexArrow(3,108);

   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer11);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,ExtMapBuffer12);

   return(0);
  }
int deinit()
  {
   return(0);
  }
int last = 0;

int start(){
   if(last == Bars) return (0);
   last = Bars;
   int counted_bars=IndicatorCounted();
   int pos;
   int cnt;
   int mult;
   double first,second;
   pos=Bars-counted_bars-1;
   if (counted_bars==0) pos=Bars-MathMax(firstback,secondback)-1;
   if (pos>countbars && countbars>0) pos=countbars;
   while (pos>-1){
      
      ExtMapBuffer1[pos]=MA(firstback, pos);
      ExtMapBuffer2[pos]=MA(secondback, pos);
      ExtMapBuffer3[pos] = EMPTY;
      ExtMapBuffer4[pos] = EMPTY;
      ExtMapBuffer11[pos]=EMPTY_VALUE;
      ExtMapBuffer12[pos]=EMPTY_VALUE;

      if((ExtMapBuffer2[pos]-ExtMapBuffer1[pos])*(ExtMapBuffer2[pos+1]-ExtMapBuffer1[pos+1])<0){
         if((ExtMapBuffer2[pos]-ExtMapBuffer1[pos])< 0) {
            ExtMapBuffer3[pos] = ExtMapBuffer1[pos];
            ExtMapBuffer11[pos]= ExtMapBuffer1[pos];
            ExtMapBuffer11[pos+1]= ExtMapBuffer1[pos+1];
         } else {
            ExtMapBuffer4[pos] = ExtMapBuffer2[pos];
            ExtMapBuffer12[pos]= ExtMapBuffer1[pos];
            ExtMapBuffer12[pos+1]= ExtMapBuffer1[pos+1];

         }
      }
      if((ExtMapBuffer2[pos]-ExtMapBuffer1[pos])< 0) {
         ExtMapBuffer11[pos]= ExtMapBuffer1[pos];
         ExtMapBuffer11[pos+1]= ExtMapBuffer1[pos+1];
      } else {
         ExtMapBuffer12[pos]= ExtMapBuffer1[pos];
         ExtMapBuffer12[pos+1]= ExtMapBuffer1[pos+1];
      }
      pos--;
   }
   return(0);
  }

double MA(int period, int pos){
   int mult=period;
   double first=0;
   double second=0;
   double tmp;
   for (int cnt=pos; cnt<pos+period; cnt++, mult--){
      tmp=MathPow(mult,power);
      first+=Close[cnt]*tmp;
      second+=tmp;
   }
   return(first/second);
}